//+------------------------------------------------------------------+
//|                          Outside the Square v1              .mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"



//---- input parameters
extern double    ProfitTarget=1.2;
extern bool      UseEquityClose=false;
extern int       EquityCloseValue=10000;

extern double    ShortLots=0.01;
extern double    LotInc= 0.01;
extern int       StepInc=1;
extern int       Step=6;
extern int       PositivePipSpace=25;
extern int       MaxSells=8;

extern bool      UseBreakEven=true;
extern string    BreakEven_Settings    = "----------BreakEvenProfit must be less than or equal to BreakEven";
extern int       BreakEven=20;
extern int       BreakEvenProfit=0;//Must be less than or equal to BreakEven

extern bool      ContinueTrading=true;

extern bool      ProfitTargetAlarm=false;
extern bool      EquityCloseAlarm=false;
extern bool      LowEquityAlarm=false;
extern int       LowEquityAmount=500;

extern int       ShortMagicNumber=400;






int              OpenShorts = 0;
double           OpenProfit=0,ClosedProfit=0,TotalLots=0;
bool             HaveHitTarget = false;
bool             HaveHitEquityTarget=false;

int              total;
double           LowestEquity=10000000;
double           HighestEquity=0;
double           LastStep;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
  if(ObjectFind("BreakEven")==0){
      ObjectDelete("BreakEven");      
   }
//----
   
//----
   return(0);
  }
  //////////////////////////////////////////////////////////  Close Pending Orders & Positions  ////////////////////////////////////////////
 void ClosePendingOrdersAndPositions()
{
  int totalorders = OrdersTotal();
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
     bool result = false;

    if ( OrderSymbol()==Symbol()&& (OrderMagicNumber()==ShortMagicNumber) ) 
     {
           //Close opened long positions
           if ( OrderType() == OP_BUY )result= OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
           //Close opened short positions
           if ( OrderType() == OP_SELL )result=  OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
           //Close pending orders
           if ( OrderType() > 1 )result=  OrderDelete( OrderTicket() );
      }
  }
  return;
}
//////////////////////////////////////////////////////////  Count Open Sells  ///////////////////////////////////////////////////////////////////
    int OpenSellPositions(  )
  {  int op =0;
     int totalorders = OrdersTotal();
     for(int i=totalorders-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && (OrderMagicNumber() == ShortMagicNumber))
         {  
          int type = OrderType();
          if ( type == OP_SELL ) {op=op+1;} 
         }
      } 
   return(op);
  }
  //////////////////////////////////////////////////////////  Count All Sells  ///////////////////////////////////////////////////////////////////
    int AllSellPositions(  )
  {  int op =0;
     int totalorders = OrdersTotal();
     for(int i=totalorders-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS);
        if ( OrderSymbol()==Symbol() && (OrderMagicNumber() == ShortMagicNumber))
         {  
          int type = OrderType();
          if ( type == OP_SELL||type==OP_SELLSTOP ) {op=op+1;} 
         }
      } 
   return(op);
  }


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  if(AccountEquity()>HighestEquity){HighestEquity=NormalizeDouble(AccountEquity(),2);}
   
   if(AccountEquity()<LowestEquity){LowestEquity=NormalizeDouble(AccountEquity(),2);}
 
  
  if(LowEquityAlarm==true && AccountEquity()<=LowEquityAmount){PlaySound("alert.wav");}
  
 
   
    int OpenShorts = OpenSellPositions();
    int AllShorts = AllSellPositions();
    
  
  
    ////////////////////////////////////////////////////  Calculate Highest & LowestSell & OrderLots  ////////////////////////////////////////
  double HighestSell=0,LowestSell=1000,SellLots;
   
   for(int count1=OrdersTotal();count1>=0;count1--)
   {
     OrderSelect(count1, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber()==ShortMagicNumber) 
	     {
	     	  if(OrderOpenPrice()>HighestSell)HighestSell=OrderOpenPrice();
	     	  
	     	  if(OrderOpenPrice()<LowestSell)LowestSell=OrderOpenPrice();
	     	  
	     	  //if(OrderLots()>SellLots)SellLots=OrderLots();
	     	  
	     	  //TotalLots+=OrderLots();
	  
	     }
   }
  
       
  
      

   

     ///////////////////////////////////////////////////////  Calculate Open Profit  ///////////////////////////////////////////////////////
     double BuyProfit=0,SellProfit=0,OpenProfit=0;
     TotalLots=0;
     
     int total =OrdersTotal();         
              
            for(int i=0;i<total;i++)                               
              {
                  OrderSelect(i, SELECT_BY_POS,MODE_TRADES );
                  if ( OrderSymbol() == Symbol())
                {
                 
                     int type = OrderType();
                   //  if ( type == OP_BUY && OrderMagicNumber()==ShortMagicNumbers) {BuyProfit=BuyProfit + OrderProfit() + OrderSwap();} 
                     if ( type == OP_SELL && OrderMagicNumber()==ShortMagicNumber)
                     { 
                     SellProfit=SellProfit + OrderProfit() + OrderSwap();
                     TotalLots+=OrderLots();
                     if(OrderLots()>SellLots)SellLots=OrderLots();
                     }
                }
              }
              OpenProfit=BuyProfit + SellProfit;
              
 ///////////////////////////////////////////////////////////   Check Profit Targets & Reset Values  /////////////////////////////////////////
    
         if  ( SellProfit>= ProfitTarget )
                                          
              { HaveHitTarget = true;}
               
  
 if (HaveHitTarget == true) 
 {      
     Print("Target Achieved Short");
     ClosePendingOrdersAndPositions();
     if(ProfitTargetAlarm==true){PlaySound("alert.wav");
     OpenProfit=0;
     
     } 
      
   }
   
   if(ContinueTrading==true && HaveHitTarget == true && OpenShorts ==0 && AccountEquity()< EquityCloseValue)
   
   {
    HighestSell=0;
    
     LowestSell=1000;
    
    HaveHitTarget=false;}
   
 
   if (UseEquityClose && AccountEquity()>=EquityCloseValue)
   {HaveHitEquityTarget = true;}
   
   if(HaveHitEquityTarget == true)
   
   { ClosePendingOrdersAndPositions();
              
     Print(" Equity Target Achieved" );
     if(EquityCloseAlarm==true){PlaySound("alert.wav");}  
     OpenProfit=0;
     
     OpenShorts=0;
     }
    
   ///////////////////////////////////////////////////////  Open First Short  ///////////////////////////////////////////////////////////
 
 if(HaveHitTarget==false && HaveHitEquityTarget==false)
 {     
 
 
  if (AllShorts <1)
  
      {
      OrderSend(Symbol(), OP_SELL, ShortLots, Bid, 3, Bid+2000*Point, 0, "FirstSell", ShortMagicNumber, Red);
      LastStep=Step;
      }
  }

 
  
 
  /////////////////////////////////////////////////////  Additional Average Up Sells  ///////////////////////////////////////////////////////
 
  
   if((Bid-(LastStep*Point))>=(HighestSell + (LastStep*Point)))
 

 {
      OrderSend(Symbol(), OP_SELLSTOP, SellLots + LotInc, Bid-(LastStep*Point), 5,0, 0, "Extra Sell", ShortMagicNumber,0, Red);
      LastStep=LastStep + StepInc;
 }
 
 
 ////////////////////////////////////////////// Additional Low Sells  ////////////////////////////////////////////////////////////////

 if ((LowestSell - Bid)>=PositivePipSpace*Point && HaveHitTarget==false && HaveHitEquityTarget==false && OpenShorts<MaxSells)
                    

 {
      OrderSend(Symbol(), OP_SELL, ShortLots, Bid, 3, Bid + 2000*Point, 0, "Trending Sell", ShortMagicNumber, Green);
     
 }
 ////////////////////////////////////////////   Calculate Break Even Line  //////////////////////////////////////////////////////// 
 
 double UltimateLots=0,RealPipValue,OrderProfits,PipLoss,BreakEven;
 
 if(OpenShorts>0)
 {
  RealPipValue=TotalLots*MarketInfo(Symbol(),MODE_TICKVALUE);
  
  PipLoss=(SellProfit-ProfitTarget)/RealPipValue;
  BreakEven=Bid + PipLoss*Point;}
  
    if (ObjectFind("BreakEven") != 0)
   {
      ObjectCreate("BreakEven", OBJ_HLINE, 0, Time[0], BreakEven);
      ObjectSet("BreakEven", OBJPROP_COLOR, Gold);
      ObjectSet("BreakEven", OBJPROP_WIDTH, 2);
   }
   else
   {
      ObjectMove("BreakEven", 0, Time[0], BreakEven);
   }   
 
 
 
        Comment("Account Balance is $",AccountBalance(),
  "\n",    "Account Equity is $",AccountEquity(),
  "\n",   "Open Profit is $",SellProfit,
  
  
  "\n",    "Sell Orders ",OpenShorts,
  
  "\n",    "Lowest Sell ",LowestSell,
  "\n",    "Highest Sell ",HighestSell,
  
  "\n",    "Sell Lots ", TotalLots,
  "\n",    "Last Step ", LastStep,
  
 
  "\n",    "Highest Equity ",HighestEquity,
  "\n",    "Lowest Equity ",LowestEquity,
   "\n",    "Account Free Margin ",AccountFreeMargin());
 

//----
   return(0);
  }
//+------------------------------------------------------------------+



